######################################
#                                    # 
#     USB Relay Board Perl Example   #
# (C)opyright 2011 EtherTek Circuits #
#                                    #
######################################

#This example shows how to use Perl to control the
#EtherTek USB Relay board.

#Reference: http://search.cpan.org/~acalpini/Win32-API-0.41/API.pm


use Win32::API;

$testBuffer = " " x 8;
$idBuffer = " " x 1024;
$manBuffer = " " x 512;
$productBuffer = " " x 512;
$versionBuffer = " " x 512;
$vm1 = " " x 32;
$vm2 = " " x 32;
$vm3 = " " x 32;
$vm4 = " " x 32;
$vm5 = " " x 32;
$vm6 = " " x 32;


$TestDLL = new Win32::API('USBrelay_DLL.dll', 'TestDLL', 'P','I');
$FindUSBrelayBoards = new Win32::API('USBrelay_DLL.dll', 'FindUSBrelayBoards', 'P','I');
$GetManufacturerString = new Win32::API('USBrelay_DLL.dll', 'GetManufacturerString', 'IP', 'I');
$GetProductString = new Win32::API('USBrelay_DLL.dll', 'GetProductString', 'IP', 'I');
$GetVersionString = new Win32::API('USBrelay_DLL.dll', 'GetVersionString', 'IP', 'I');
$ReadUSBrelays = new Win32::API('USBrelay_DLL.dll', 'ReadUSBrelays', 'IP', 'I');
$WriteUSBrelay = new Win32::API('USBrelay_DLL.dll', 'WriteUSBrelay', 'III', 'I');
 

# Test DLL connectivity
$TestDLL->Call($testBuffer);
$testBuffer =~ s/\s+$//; #remove trailing spaces
print "DLL is => " . $testBuffer . "\n";

#Get USBrelay boards attached to system
$FindUSBrelayBoards->Call($idBuffer);
$idBuffer =~ s/\s+$//; #remove trailing spaces
$ID = substr($idBuffer, 0, - 2); #strip the pipe.
print "USB Relay Board IDs found => " . $ID . "\n";

#Get Manufacturer String
$GetManufacturerString->Call(hex $ID,$manBuffer);
$manBuffer =~ s/\s+$//; #remove trailing spaces
print "Manufacturer String => " . $manBuffer . "\n";

#Get Product String
$GetProductString->Call(hex $ID,$productBuffer);
$productBuffer =~ s/\s+$//; #remove trailing spaces
print "Product String => " . $productBuffer . "\n";

#Get Version String
$GetVersionString->Call(hex $ID,$versionBuffer);
$versionBuffer =~ s/\s+$//; #remove trailing spaces
print "Version String => " . $versionBuffer . "\n";

#Energize Relay 1
$WriteUSBrelay->Call(hex $ID,1,0);
print "Relay 1 ON\n";

sleep 1;

#De-Energize Relay 1
$WriteUSBrelay->Call(hex $ID,0,0);
print "Relay 1 OFF\n";

sleep 1;

#Energize Relay 2
$WriteUSBrelay->Call(hex $ID,3,0);
print "Relay 2 ON\n";

sleep 1;

#De-Energize Relay 2
$WriteUSBrelay->Call(hex $ID,2,0);
print "Relay 2 OFF\n";

sleep 1;

#Energize Relay 3
$WriteUSBrelay->Call(hex $ID,5,0);
print "Relay 3 ON\n";

sleep 1;

#De-Energize Relay 3
$WriteUSBrelay->Call(hex $ID,4,0);
print "Relay 3 OFF\n";

sleep 1;

#Energize Relay 4
$WriteUSBrelay->Call(hex $ID,7,0);
print "Relay 4 ON\n";

sleep 1;

#De-Energize Relay 4
$WriteUSBrelay->Call(hex $ID,6,0);
print "Relay 4 OFF\n";

sleep 1;

#Energize Relay 5
$WriteUSBrelay->Call(hex $ID,9,0);
print "Relay 5 ON\n";

sleep 1;

#De-Energize Relay 5
$WriteUSBrelay->Call(hex $ID,8,0);
print "Relay 5 OFF\n";
